package jGDK;

import java.util.Hashtable;
import java.util.Vector;

/**
 * <p>Title: Fred v.2.0 - Record.java</p>
 * @author Cezary Dowhan
 * @version 2.0
 */

public class Record
{
  public String		sort;
  public Hashtable	info;
  public Vector		parameters;
  
  private String		key;
  private Hashtable	hashtable;
  
  // constructor ----------------------------------------------------------
  
  /**		 */
  
  Record()
  {
    parameters = new Vector();
  }
  //the end of initial section --------------------------------------
  
  /**		*/
  
  public void addInfo(Hashtable param)
  {
    info = param;
  }
  //-----------------------------------------------------------------
  
  /**		*/
  
  public void addParameter(Hashtable param)
  {
    parameters.addElement(param);
  }
  //-----------------------------------------------------------------
  
  /** 	 */
  
  public Object getInfoAbout(String parameter)
  {
    return info.get(parameter);
  }
  //-----------------------------------------------------------------
  
  /**		 */
  
  public String getParamAtPos(int position)
  {
    if (position >= parameters.size())
      return null;
    hashtable = (Hashtable) parameters.get(position);
    return (String) hashtable.get("id");
  }
  //-----------------------------------------------------------------
  
  /** 	 */
  
  public int getPosOfParam(String parameter)
  {
    for (int index=0; index<parameters.size() ; index++ )
    {
      hashtable = (Hashtable) parameters.get(index);
      key	= (String) hashtable.get("id");
      if (key != null && key.equals(parameter))
        return index;
    }
    return -1;
  }
  //-----------------------------------------------------------------
  
  /**		 */
  
  public Object getParamProperty(String parameterId, String property)
  {
    for (int index=0; index<parameters.size() ; index++ )
    {
      hashtable = (Hashtable) parameters.get(index);
      key	= (String) hashtable.get("id");
      if (key != null && key.equals(parameterId))
      {
        if (hashtable.containsKey(property))
          return hashtable.get(property);
      }
    }
    return null;
  }
  
  //-----------------------------------------------------------------
  
  /**		 */
  
  public String toString()
  {
    StringBuffer buffer = new StringBuffer();
    buffer.append("Info -------\n");
    buffer.append(info.toString()+"\n");
    buffer.append("Parameters -\n");
    for (int i = 0; i < parameters.size(); i++)
      buffer.append(i+" --> "+((Hashtable) parameters.get(i)).toString()+"\n");
    return buffer.toString();
  }
};
